/****************************************************************
*	EGAPAL.C - try to display the EGA palette from within MSC	*
*	To compile "cl egapal.c /link graphics"						*
****************************************************************/

#include <stdio.h>
#include <dos.h>
#include <graph.h>
#include <ctype.h>
#include <conio.h>

#define TRUE	(1==1)
#define FALSE	(!TRUE)

void main(void)
	{
	char buf[100];
	int c, color, i, originalColor, quit;
	union REGS regs;

	/*------ Save the current palette mapping of color 1 -------*/
	regs.x.ax = 0x1007;
	regs.x.bx = 1;
	int86(0x10,&regs,&regs);
	originalColor = regs.h.bh;

	/*-------------------- Set up the screen -------------------*/
	_setbkcolor(0);					/* Draw the big block on	*/
	_clearscreen(_GCLEARSCREEN);	/* the screen				*/
	_displaycursor(_GCURSOROFF);
	_setbkcolor(1);
	for (i=5; i<16; i++)
		{
		_settextposition(i, 25);
		_outtext("                              ");	/* 40 spaces */
		}
	_setbkcolor(0);
	_settextposition(22,23);
	_outtext("N=Next color, P=Prev color, Q=quit");

	/*---------------- Demonstration main loop -----------------*/
	for (color=1, quit=FALSE; !quit; )
		{
		/* Remap current palette register 1 to specified color */
		regs.x.ax = 0x1000;
		regs.h.bh = (unsigned char)color;
		regs.h.bl = 1;
		int86(0x10,&regs,&regs);
		sprintf(buf,"Palette color %d ",color);
		_setbkcolor(0);
		_settextposition(20,32);
		_outtext(buf);

		/* Process the user's command */
		c=getch();
		switch (toupper(c))
			{
			case 'N':	/* Next color */
				if (++color > 63)
					color = 0;
				break;

			case 'P':	/* Previous color */
				if (--color < 0)
					color = 63;
				break;

			case 'Q':	/* Quit command */
				quit = TRUE;
				break;

			default:	/* Error - invalid key pressed */
				fputc('\a',stderr);
				break;
			}
		}

	/*------ Save the current palette mapping of color 1 -------*/
	_displaycursor(_GCURSORON);
	regs.x.ax = 0x1000;
	regs.h.bh = (unsigned char)originalColor;
	regs.h.bl = 1;
	int86(0x10,&regs,&regs);
	originalColor = regs.h.bh;
	}
